diff --git a/stmhal/main.c b/stmhal/main.c
index 41ebaf3bb55..3434f3ea580 100644
--- a/stmhal/main.c
+++ b/stmhal/main.c
@@ -115,6 +115,12 @@ void nlr_jump_fail(void *val) {
     __fatal_error("");
 }
 
+void __assert_func(const char *file, int line, const char *func, const char *expr) {
+    (void)func;
+    printf("Assertion '%s' failed, at file %s:%d\n", expr, file, line);
+    __fatal_error("");
+}
+
 STATIC mp_obj_t pyb_config_source_dir = MP_OBJ_NULL;
 STATIC mp_obj_t pyb_config_main = MP_OBJ_NULL;
 STATIC mp_obj_t pyb_config_usb_mode = MP_OBJ_NULL;
